;; Gewindebohrung mit Mittellinien zeichnen
;; Mit Dialog: GEW.DCL
;; Mai 04   V 1.4
;;
(defun C:GEW (/ MP D1 D2 R L STP ELEM SIZ AZ ST LEER)

  (defun NEUERR (MSG)
  (princ MSG)
  (command "REGEN")
  (R_VAR)
  (exit)
  (princ)
 )

 (setq ALTERR  *ERROR*
       *ERROR* NEUERR
       C_E (getvar "CMDECHO")           ; ECHO
       B_M (getvar "BLIPMODE")          ; Markierungspunkte
       O_M (getvar "OSMODE")            ; Fang
       C_L (getvar "CLAYER")            ; LAYER
       LEER (strcat "\n" (chr 160) "\n" (chr 160) "\n" (chr 160)); zum Befehlszeile subern
 )

 (setvar "CMDECHO" 0)
;; Layer, Faben und Linienarten knnen je nach Wunsch gendert werden.
 (if (not (tblsearch "LAYER" "1"))
  (command "LAYER" "MACH" "1" "FA" "1" "" "")
 )
 (if (not (tblsearch "LAYER" "2"))
  (command "LAYER" "MACH" "2" "FA" "2" "" "")
 )

 (defun R_VAR ()
  (setvar "BLIPMODE" B_M)
  (setvar "OSMODE" O_M)
  (command "LAYER" "SE" C_L "")         ; Layer ruecksetzen
  (setq *ERROR* ALTERR)
  (command "REGEN")
  (setvar "CMDECHO" C_E)
  (setq SIZ NIL AZ NIL)
 )

 ;;--------------------------------
 (defun GE_NE (/ NAMES SIZ_N SIZ_Z)

  (setq NAMES '("M3" "M4" "M5" "M6" "M8" "M10" "M12" "M16" "Andere"))
  (setq DCL_ID (load_dialog "gew.dcl"))
  (if (not (new_dialog "GEW" DCL_ID))
   (exit)
  )

  (start_list "ausw")                   ;List box starten
  (mapcar 'add_list NAMES)              ;List box fllen
  (end_list)                            ;end list
  (action_tile "cancel" "(done_dialog)")
  (action_tile "accept"
   (strcat
    "(progn
      (setq SIZ_N (get_tile \"ausw\"))" ;Auswahl
    " (done_dialog))"                   ;close dialog
   ) ;_strcat
  ) ;_action tile

  (start_dialog)
  (unload_dialog DCL_ID)

  (setq SIZ_Z (fix (atof SIZ_N)))
  (setq SIZ (nth SIZ_Z NAMES))
 ) ;_end defun ge_ne
 (princ)

 ;;------------------------------
 (GE_NE)
 (if (= SIZ "Andere")
  (progn
   (princ LEER)
   (setq D1 (getreal "Gewinde-Durchmesser: "))
   (setq ST (getreal "\nGewinde-Steigung: "))
  )
  (setq D1 (atoi (substr SIZ 2)))
 )
 (cond
  ((= D1 3) (setq D2 2.5))
  ((= D1 4) (setq D2 3.3))
  ((= D1 5) (setq D2 4.2))
  ((= D1 6) (setq D2 5.0))
  ((= D1 8) (setq D2 6.7))
  ((= D1 10) (setq D2 8.5))
  ((= D1 12) (setq D2 10.25))
  ((= D1 16) (setq D2 14.0))
  (D1 (setq D2 (- D1 ST)))           ; sonst
 )
 (princ LEER)
 (prompt "Mittelpunkt der Gewindebohrung oder weiter mit einer Taste: ")
 (setq AZ 1)
 (while (= AZ 1)
  (setq MP NIL)
  (setq MP (getpoint))
  (if (not MP)
   (setq AZ 0)
   (progn
    (setq R (/ D1 2.0))                    ; Kreisradius
    (setq L (+ R 3))                       ; 3 mm Ueberstand
    (setq STP (list (- (nth 0 MP) R) (nth 1 MP)))
    (setvar "OSMODE" 0)
    (setvar "BLIPMODE" 0)
    (command
     "LAYER" "SE" "0" ""
     "_CIRCLE" MP "D" D2
     "LAYER" "SE" "2" ""
     "_ARC" STP "_C" MP "_A" 270
    )
    (setq ELEM (entlast))
    (command
     ;; Bogen um 15 drehen
     "DREHEN" ELEM "" MP "15"
     ;; Mittellinien zeichnen
     "LAYER" "SE" "1" ""
     "_LINE" MP (polar MP 0 L) ""
     "_LINE" MP (polar MP (* pi (/ 90.0 180.0)) L) ""
     "_LINE" MP (polar MP pi L) ""
     "_LINE" MP (polar MP (* pi (/ 270.0 180.0)) L) ""
    )
    (setvar "OSMODE" O_M)
   ) ;_ end Progn
  ) ;_ end if
 ) ;_end while
 (princ LEER)
 (R_VAR)
 (princ)
)
(prompt "\nStarten mit \"gew\"")
(princ)
