;; Mittellinie zeichnen an Kreise, Bgen, Linien LWPolylinien und Polylinien
;; Die Mittellinien werden zu einer Gruppe zusammengefgt.
;; (d) Schnwald
;; 28.7.2003  V 4.0  ACAD2000
;;
(defun C:M_L (/ ELEM ELDA KR L P1 P2 P3 P4 DS WB WG WB1 DS2 CLTS E1 E2 E3 E4 AS LEER)

 (defun *ERROR* (MSG) (R_VAR) (princ MSG) (princ))
 (setq C_E (getvar "CMDECHO")           ; ECHO
       C_L (getvar "CLAYER")            ; Layer
       O_M (getvar "OSMODE")            ; Fang
       G_M (getvar "GRIDMODE")          ; Raster
       C_S (getvar "CELTSCALE")         ; Linienscalierung lokal
       W_K (getvar "UCSORG")            ; BKS
       LEER    (strcat "\n" (chr 160) "\n" (chr 160) "\n" (chr 160) "\n")
 )
 (setvar "CMDECHO" 0)
 (setvar "OSMODE" 0)
 (setvar "GRIDMODE" 0)
 (command "_UCS" "_W")

 ;; Hier kann man einen persnlichen Layer einstellen.
 ;; Eingestellt ist: Layer 1, Farbe 1, Linientyp MITTE
 (if (not (tblsearch "LAYER" "1"))
  (command "LAYER" "MACH" "1" "_COLOR" "1" "" "LT" "MITTE" "" "")
  (command "LAYER" "SE" "1" "")
 )

 (defun R_VAR ()
  (setvar "OSMODE" O_M)
  (setvar "GRIDMODE" G_M)
  (command "LAYER" "_SET" C_L "" "REGEN")
  (command "_UCS" "N" W_K)
  (setvar "CELTSCALE" C_S)
  (setvar "CMDECHO" C_E)
 )
 ;;--------------------------------------------------------------
 (princ LEER)
 (setq ELEM (entsel "\nBitte einen Kreis, Bogen oder Linie whlen: "))
 (setq ELDA (entget (car ELEM)))
 (if (or (= (cdr (assoc 0 ELDA)) "CIRCLE") ; wenn Kreis
         (= (cdr (assoc 0 ELDA)) "ARC") ; wenn Bogen
     )
  (progn                                ; dann ...
   (setq MP (cdr (assoc 10 ELDA))
         RA (cdr (assoc 40 ELDA))
         L  (+ RA 3)                    ; 3 mm Ueberstand
   )
   (if (and (>= RA 2) (< RA 15))
    (setq CLTS (* RA 0.08))
    (if (< RA 2)
     (setq CLTS 0.16)
     (setq CLTS 1)
    )
   )
   (setq CLTS (distof (rtos CLTS 2 2)))
   (setvar "CELTSCALE" CLTS)
   (command "regen")
   (setq AS (ssadd))
   (command "_LINE" MP (polar MP 0 L) "")
   (setq E1 (entlast))
   (ssadd E1 AS)
   (command "_LINE" MP (polar MP (* pi (/ 90.0 180.0)) L) "")
   (setq E2 (entlast))
   (ssadd E2 AS)
   (command "_LINE" MP (polar MP pi L) "")
   (setq E3 (entlast))
   (ssadd E3 AS)
   (command "_LINE" MP (polar MP (* pi (/ 270.0 180.0)) L) "")
   (setq E4 (entlast))
   (ssadd E4 AS)
   (command "_group" "" "*" "" AS "")
  ) ;_end progn
 ) ;_end if
 (if (or (= (cdr (assoc 0 ELDA)) "LINE") ; wenn ...
         (= (cdr (assoc 0 ELDA)) "POLYLINE")
         (= (cdr (assoc 0 ELDA)) "LWPOLYLINE")
     )
  (progn
   (setvar "OSMODE" 2)                  ; Fang
   (setq P1 (osnap (cadr ELEM) "_MID")) ; Anpickpunkt Mitte
   (princ LEER)
   (setq P2 (getpoint "\n... zur nchsten Linie: "))
   (setq DS (distance P1 P2))
   (setq WB (angle P1 P2))
   (setq WG (/ (* WB 180.0) pi))
   (setq WB1 (* pi (/ (+ 180 WG) 180.0)))
   (setq DS2 (+ DS 6.0))
   (setq P3 (polar P1 WB1 3.0))
   (setq P4 (polar P3 WB DS2))
   (command "_LINE" P3 P4 "")           ; zeichnen
  )
 )
 (R_VAR)
 (princ)
)                                       ; End defun
(princ)

