;;; Funktion: Bezugslinien mit Positionsnummern schreiben
;;; Die Datei NUM.DWG muss in einem aktuellen Verzeichnis sein und
;;; 1/95    V 1.2

(defun C:NUM (/ p1 p2 dxx dx dyy dy)

 (defun NEUERR (MSG) (R_VAR) (princ MSG) (princ))

 (setq ALTERR  *ERROR*
       *ERROR* NEUERR
       c_e     (getvar "CMDECHO")       ; ECHO
       a_d     (GETVAR "ATTDIA")        ; Attribut-DIA
       c_l     (GETVAR "CLAYER")        ; LAYER
       p_m     (GETVAR "PDMODE")        ; Punktmuster
       p_s     (GETVAR "PDSIZE")        ; Punktgroesse
 )

 (SETVAR "CMDECHO" 0)
 (SETVAR "ATTDIA" 0)
 (if (not (tblsearch "LAYER" "2"))
  (command "LAYER" "MACH" "2" "FA" "2" "" "")
 )

 (DEFUN R_VAR ()
  (setq *ERROR* ALTERR)
  (SETVAR "ATTDIA" a_d)
  (SETVAR "PDMODE" p_m)
  (SETVAR "PDSIZE" p_s)
  (command "LAYER" "SE" c_l "" "REGEN")
  (SETVAR "CMDECHO" c_e)
 )

 (GRAPHSCR)
 ;;-------------------------------------
 (setq weiter t)
 (while weiter
  (setq num_max 0)
  (setq asa (ssget "x" (list (cons 2 "NUM"))))
  (if (/= asa nil)
   (progn
    (setq lasa (sslength asa))          ; Anzahl
    (setq num_max 0)
    (setq nak 0)
    (while (< nak lasa)
     (setq e (ssname asa nak))          ; Elementname
     (setq li (entget e))               ; Liste
     (setq v (entnext e))               ; naechste Liste
     (setq z (assoc 66 li))             ; Folgeliste?

     (while (/= z nil)                  ; wenn Folgeliste
      (setq nummer (cdr (assoc 1 (entget v)))) ; aktuelle Nummer
      (if (= (type nummer) 'STR)
       (progn
        (setq nummer (atoi nummer))
        (setq num_max (max num_max nummer))
       ) ;_ end progn
      ) ;_ end if
      (setq z (/= (cdr (assoc 0 (entget v))) "SEQEND"))
      (setq v (entnext v))              ; nchste Liste
     ) ;_ end while /= z nil
     (setq nak (1+ nak))                ; inkr Nummer
    ) ;_ end while
   ) ;_ end progn
  ) ;_ end if

  (setq num_max (1+ num_max))           ; neue Vorgabe
  (prompt "\n. \n. \n")
  (princ "\n \nBauteilnummer <")        ; anzeigen
  (princ num_max)                       ; Vorgabenummer
  (setq temp (getint ">: "))            ; abfragen
  (if temp
   (setq num_max temp)
  )                                     ; wenn nicht return

  (setq
   p1 (getpoint
       "\n. \n. \nReturn fr Exit/Startpunkt der Linie anklicken: "
      )
  )
  (if p1
   (progn
    (initget 1)
    (setq p2 (getpoint "\n. \n. \nEndpunkt der Linie anklicken: "))
    (initget "J N")
    (setq
     pu (getkword
         "\n: \n. \n. \nPunkt am Anfang der Linie setzen? N/<J>: "
        )
    )
    (if (not (= pu "N"))
     ;; Layer, Punktsymbol und -Durchmesser setzen
     (command "LAYER" "SE" "0" "" "PDMODE" "33" "PDSIZE" "0.4" ".PUNKT" p1)
    )
    (command "LAYER" "SE" "2" "" "_LINE" p1 p2 "")
   ) ;_ end progn
   (progn
    (setq weiter nil
          P2 NIL
    )
   )
  ) ;_ end if p1

  (if p2
   (progn
    (SETQ dxx (- (car p2) (car p1))
          dx  (- (car p1) (car p2))
          dyy (- (cadr p2) (cadr p1))
          dy  (- (cadr p1) (cadr p2))
    )
    (if (and (> dyy dxx) (> dxx dy) (> dyy dx)) ; Linie von oben
     (setq p (list (car p2) (+ (cadr p2) 4)))
    )
    (if (and (> dy dyy) (> dy dx))              ; ... unten
     (setq p (list (car p2) (- (cadr p2) 9)))
    )
    (if (and (> dxx dx) (> dxx dyy) (> dyy dx)) ; ... links
     (setq p (list (+ (car p2) 6) (- (cadr p2) 2)))
    )
    (if (and (> dx dyy) (> dx dy) (or (> dyy dy) (> dy dyy))) ; rechts
     (setq p (list (- (car p2) 6) (- (cadr p2) 2)))
    )
    (command "LAYER" "SE" "0" "" "_INSERT" "NUM" p "2" "2" "" num_max)
   ) ;_end progn
  ) ;_end if
 ) ;_ end while weiter
 (R_VAR)
 (princ)
)                                       ; end defun c:...
(princ)

