;; Senkungung mit Mittellinien zeichnen
;; Mit Dialog: SENK.DCL
;; Mai 04   V 1.1 (d) Th. Schoenwald
;;
(defun C:SENK (/ MP D1 D2 D3 R L STP ELEM SIZ AZ LEER)

  (defun NEUERR (MSG)
  (princ MSG)
  (command "REGEN")
  (R_VAR)
  (exit)
  (princ)
 )

 (setq ALTERR  *ERROR*
       *ERROR* NEUERR
       C_E (getvar "CMDECHO")           ; ECHO
       B_M (getvar "BLIPMODE")          ; Markierungspunkte
       O_M (getvar "OSMODE")            ; Fang
       C_L (getvar "CLAYER")            ; LAYER
       LEER (strcat "\n" (chr 160) "\n" (chr 160) "\n" (chr 160));zum Befehlszeile subern
 )

 (setvar "CMDECHO" 0)
;; Layer, Faben und Linienarten knnen je nach Wunsch gendert werden.
 (if (not (tblsearch "LAYER" "1"))
  (command "LAYER" "MACH" "1" "FA" "1" "" "")
 )

 (defun R_VAR ()
  (setvar "BLIPMODE" B_M)
  (setvar "OSMODE" O_M)
  (command "LAYER" "SE" C_L "")         ; Layer ruecksetzen
  (setq *ERROR* ALTERR)
  (command "REGEN")
  (setvar "CMDECHO" C_E)
  (setq SIZ NIL AZ NIL)
 )

 ;;--------------------------------
 (defun GE_NE (/ NAMES SIZ_N SIZ_Z)

  (setq NAMES '("M3" "M4" "M5" "M6" "M8" "M10" "M12" "M16" ))
  (setq DCL_ID (load_dialog "senk.dcl"))
  (if (not (new_dialog "SENK" DCL_ID))
   (exit)
  )
  (set_tile "AZ" "1")
  (setq AZ (get_tile "AZ"))

  (start_list "ausw")                   ;List box starten
  (mapcar 'add_list NAMES)              ;List box fllen
  (end_list)                            ;end list
  (action_tile "AZ" "(SETQ AZ (ATOI $VALUE))")
  (action_tile "cancel" "(done_dialog)")
  (action_tile "accept"
   (strcat
    "(progn
      (setq SIZ_N (get_tile \"ausw\"))" ;Auswahl
    " (done_dialog))"                   ;close dialog
   ) ;_strcat
  ) ;_action tile

  (start_dialog)
  (unload_dialog DCL_ID)

  (if (= (type AZ) 'STR)
   (setq AZ (atoi AZ))
  )
  (setq SIZ_Z (fix (atof SIZ_N)))
  (setq SIZ (nth SIZ_Z NAMES))
 ) ;_end defun ge_ne
 (princ)

 ;;------------------------------
 (GE_NE)
 (setq D1 (atoi (substr SIZ 2)))
 (cond
  ((= D1 3) (setq D2 3.4 D3 6.5))
  ((= D1 4) (setq D2 4.5 D3 8.0))
  ((= D1 5) (setq D2 5.5 D3 10.0))
  ((= D1 6) (setq D2 6.6 D3 11.0))
  ((= D1 8) (setq D2 9.0 D3 15.0))
  ((= D1 10) (setq D2 11 D3 18.0))
  ((= D1 12) (setq D2 13.5 D3 20.0))
  ((= D1 16) (setq D2 17.5 D3 25.0))
 )
 
 (princ LEER)                            
 (prompt "Mittelpunkt der Senkung oder weiter mit einer Taste: ")
 (setq AZ 1)
 (while (= AZ 1)     
  (setq MP NIL)
  (setq MP (getpoint))
  (if (not MP)
   (setq AZ 0)
   (progn
    (setq R (/ D3 2.0))                  ; Kreisradius
    (setq L (+ R 3))                     ; 3 mm Ueberstand
    (setq STP (list (- (nth 0 MP) R) (nth 1 MP)))
    (setvar "OSMODE" 0)
    (setvar "BLIPMODE" 0)
    (command "LAYER" "SE" "0" ""
             "_CIRCLE" MP "D" D2
             "_CIRCLE" MP "D" D3
    )
    (setq ELEM (entlast))
    ;; Mittellinien zeichnen
    (command
     "LAYER" "SE" "1" "" "_LINE" MP (polar MP 0 L) ""
     "_LINE" MP (polar MP (* pi (/ 90.0 180.0)) L) ""
     "_LINE" MP (polar MP pi L) ""
     "_LINE" MP (polar MP (* pi (/ 270.0 180.0)) L) ""
    )
    (setvar "OSMODE" O_M)
   ) ;_ end Progn
  ) ;_ end if
 ) ;_end while
 (princ LEER)
 (R_VAR)
 (princ)
)
(prompt "\nStarten mit \"senk\"")
(princ)
